<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfJP_PackageInsurance ArrayType
 * @subpackage Arrays
 */
class ArrayOfJP_PackageInsurance extends AbstractStructArrayBase
{
    /**
     * The Insurance
     * Meta informations extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\JP_PackageInsurance[]
     */
    public $Insurance;
    /**
     * Constructor method for ArrayOfJP_PackageInsurance
     * @uses ArrayOfJP_PackageInsurance::setInsurance()
     * @param \StructType\JP_PackageInsurance[] $insurance
     */
    public function __construct(array $insurance = array())
    {
        $this
            ->setInsurance($insurance);
    }
    /**
     * Get Insurance value
     * @return \StructType\JP_PackageInsurance[]|null
     */
    public function getInsurance()
    {
        return $this->Insurance;
    }
    /**
     * Set Insurance value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageInsurance[] $insurance
     * @return \ArrayType\ArrayOfJP_PackageInsurance
     */
    public function setInsurance(array $insurance = array())
    {
        foreach ($insurance as $arrayOfJP_PackageInsuranceInsuranceItem) {
            // validation for constraint: itemType
            if (!$arrayOfJP_PackageInsuranceInsuranceItem instanceof \StructType\JP_PackageInsurance) {
                throw new \InvalidArgumentException(sprintf('The Insurance property can only contain items of \StructType\JP_PackageInsurance, "%s" given', is_object($arrayOfJP_PackageInsuranceInsuranceItem) ? get_class($arrayOfJP_PackageInsuranceInsuranceItem) : gettype($arrayOfJP_PackageInsuranceInsuranceItem)), __LINE__);
            }
        }
        $this->Insurance = $insurance;
        return $this;
    }
    /**
     * Add item to Insurance value
     * @throws \InvalidArgumentException
     * @param \StructType\JP_PackageInsurance $item
     * @return \ArrayType\ArrayOfJP_PackageInsurance
     */
    public function addToInsurance(\StructType\JP_PackageInsurance $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\JP_PackageInsurance) {
            throw new \InvalidArgumentException(sprintf('The Insurance property can only contain items of \StructType\JP_PackageInsurance, "%s" given', is_object($item) ? get_class($item) : gettype($item)), __LINE__);
        }
        $this->Insurance[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\JP_PackageInsurance|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\JP_PackageInsurance|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\JP_PackageInsurance|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\JP_PackageInsurance|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\JP_PackageInsurance|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string Insurance
     */
    public function getAttributeName()
    {
        return 'Insurance';
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructArrayBase::__set_state()
     * @uses AbstractStructArrayBase::__set_state()
     * @param array $array the exported values
     * @return \ArrayType\ArrayOfJP_PackageInsurance
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
